/*
	This code © 2019 Marco Balestra - balestra@altersoftware.it
	
	This code is 100% Microsoft-free, Java-free, Angular-free.
	Developed on Mac OS X in a 100% Microsoft-free environment.
	
	- Requires as-core.js
	- jquery is not required
	- Pupulates objects "AS.label" and "AS.labels"
*/

AS.labels = {
	def : AS.prop.defaultLang ? AS.prop.defaultLang : 'en',
	init : ( lang ) => {
		if ( (! document) || (! document.documentElement) ) return setTimeout( function() { AS.labels.init(lang); }, 10 );
		if ( lang && AS.test.str(lang) && ( lang.length >= 2 ) ) {
			AS.labels.setLanguage( lang.replace(/^(..).*$/,"$1").toLowerCase() );
		} else if ( AS.def.str(AS.getCookie('forcelang')).match(/^[a-z]{2}/i) ) {
			AS.labels.setLanguage( AS.getCookie('forcelang').replace(/^([a-z]{2}).*$/i,"$1").toLowerCase() );
		} else if ( document.documentElement.getAttribute('lang') ) {
			AS.labels.setLanguage( document.documentElement.getAttribute('lang').replace(/^(..).*$/,"$1").toLowerCase() );
		} else if ( document.documentElement.getAttribute('xml:lang') ) {
			AS.labels.setLanguage( document.documentElement.getAttribute('xml:lang').replace(/^(..).*$/,"$1").toLowerCase() );
		} else if ( AS.def.str(AS.getCookie('language')).match(/^[a-z]{2}/i ) ) {
			AS.labels.setLanguage( AS.getCookie('language').replace(/^([a-z]{2}).*$/i,"$1").toLowerCase() );
		} else if ( AS.def.str(AS.getCookie('lang')).match(/^[a-z]{2}/i ) ) {
			AS.labels.setLanguage( AS.getCookie('lang').replace(/^([a-z]{2}).*$/i,"$1").toLowerCase() );
		} else if ( window.navigator.userLanguage || window.navigator.language ) {
			let l = window.navigator.userLanguage || window.navigator.language;
			AS.labels.setLanguage( l.replace(/^(..).*$/,"$1").toLowerCase() );
		} else {
			AS.labels.setLanguage();
		}
		setTimeout( AS.labels.page, 1 );
	},
	forceLang: (l) => { AS.setCookie('forcelang',l,{path:'/', domain: true, firstLevel: true }); },
	include : ( name ) => { AS.labels.loadjs( 'key-for-'+name, name, true ); },
	labelize : ( txt ) => {
		while ( txt.match(/\{\{label:[^}]+\}(\{[^:]+:[^}]+\})*\}/) ) {
			txt = txt.replace(/\{\{label:([^}]+)\}((\{[^:]+:[^}]*\})*)\}/g,function(x,y,z){
				let v = false;
				if ( z && (z.length > 0) ) {
					v = {};
					z = z.replace(/\{([^:]+):([^}]*)\}/g,function(a,b,c) {
						c = c.replace(/^label:(.+)/g,function(m,n){ return AS.label(n) });
						v[b] = c;
						return '';
					});
				}
				return AS.label(y,v);
			});
		}
		while ( txt.match(/\{\{icon:[^}]+\}\}/) ) {
			txt = txt.replace(/\{\{icon:([^}]+)\}\}/g,function(x,y){ return AS.icon(y); });
		}
		return txt;
	},
	labelizeAll : ( iterations ) => {
		if (document.documentElement.querySelector('head meta[name="AS.labels.dontLabelize"]')) {
			AS.labels.newloadstarted = false;
			AS.labels.loading = false;
			AS.labels.loaded = true;
			return true;
		}
		iterations = AS.def.num( iterations );
		if ( iterations > 30 ) {
			AS.labels.newloadstarted = false;
			AS.labels.loading = false;
			AS.labels.loaded = true;
			return void(0);
		}
		iterations++;
		if ( AS.labels.pending > 0 ) return setTimeout( ()=>{ AS.labels.labelizeAll( iterations ); }, 100);
		if ( ! AS.test.obj(AS.labels.lang[ AS.labels.main ]) ) return setTimeout( ()=>{ AS.labels.labelizeAll( iterations ); }, 100);
		if ( ! AS.test.obj(AS.labels.lang[ AS.labels.def ]) ) return setTimeout( ()=>{ AS.labels.labelizeAll( iterations ); }, 100);
		let e;
		try {
			let body = document.getElementsByTagName('body')[0];
			if ( typeof body === 'undefined' ) return  setTimeout( AS.labels.labelizeAll, 10)
			AS.labels.loading = true;
			body.innerHTML = AS.labels.labelize( body.innerHTML );
			let h = document.documentElement.querySelector('head');
			let wt = h.querySelector('title');
			if ( wt ) {
				let e;
				try {
					let ot = wt.innerHTML;
					let nt = AS.labels.labelize( ot );
					if ( ot != nt ) {
						wt.innerHTML  = nt;
						document.title = nt;
					}
				} catch(e) {
					console.debug(e);
				}
			}
			let cs = h.querySelectorAll('style.ASloadingLanguages');
			if ( cs.length > 0 ) for ( let i = 0; i < cs.length; i++ ) h.removeChild( cs[i] );
			AS.labels.newloadstarted = false;
			AS.labels.loading = false;
			AS.labels.loaded = true;
		} catch(e) {
			return setTimeout( ()=>{ AS.labels.labelizeAll( iterations ); }, 100);
		}
	},
	lang : {},
	langloaded: {},
	load : ( lang, obj ) => {
		if ( typeof AS.labels.lang[ lang ] != 'object' ) AS.labels.lang[ lang ] = {};
		if ( ! AS.test.arr( obj ) ) obj = [obj];
		for ( let i = 0; i < obj.length; i++ ) if ( AS.test.obj( obj[i] ) ) {
			for ( let k in obj[i] ) {
				if ( k.substring(0,1) == '!' ) {
					AS.labels.lang[ lang ][ k.replace(/^! */,'') ] = obj[ i ][ k ]
				} else if (! AS.labels.lang[ lang ][ k ] ) {
					AS.labels.lang[ lang ][ k ] = obj[ i ][ k ];
				}
			}
		}
		AS.labels.pending--;
	},
	loaded : false,
	loading : false,
	loadjs : ( key, name, skipNewLoad ) => {
		if (document.documentElement.querySelector('head meta[name="AS.labels.dontLoad"]')) return true;
		if ( ! name ) name = String(key);
		if ( AS.labels.langloaded[ name ] ) return false;
		AS.labels.pending++;
		AS.labels.loaded = false;
		let s = document.createElement('script');
		s.setAttribute('type','text/javascript');
		s.setAttribute('language','javascript');
		s.setAttribute('charset','utf-8');
		let path = name + '.js';
		if ( path.indexOf('/') < 0 ) {
			let ts = document.querySelector('script[src$="/as-labels.js"]');
			if ( ts.getAttribute('AS'+name) ) {
				path = ts.getAttribute('AS'+name)+path;
			} else if ( ts.getAttribute('ASlabels') ) {
				path = ts.getAttribute('ASlabels')+path;
			} else if ( AS.path && (AS.path('labels') || AS.path(name) ) ) {
				let basepath;
				if ( AS.path(name) ) {
					basepath = AS.path(name);
				} else if ( name == key ) {
					basepath = AS.path('labels');
				} else {
					basepath = AS.path('labels').replace(/\/[^\/]+$/,'/');
				}
				path = basepath + path;
			}
		}
		s.setAttribute('src', path );
		s.setAttribute('id','AS-autoloadjs-labels-'+name);
		s.onerror = function() {
			console.log('[AS.labels] Error loading language script: '+path+' - '+this.src);
			AS.labels.pending--;
		};
		document.documentElement.querySelector('head').appendChild(s);
		AS.labels.langloaded[name] = true;
		if ( skipNewLoad ) return true;
		AS.labels.newload();
	},
	loadmultijs : ( list ) => {
		if ( AS.labels.loading ) return setTimeout( function(){ AS.labels.loadmultijs(list); }, 10);
		if ( ! list ) return void(0);
		if ( ! AS.test.arr(list) ) list = [ list ];
		if ( list.length < 1 ) return void(0);
		let newload = false;
		for ( let i = 0; i < list.length; i++ ) {
			let o = list[i];
			if ( ! AS.test.obj( o ) ) o = { key: String(o) };
			newload = AS.labels.loadjs( o.key, o.name, true ) || newload;
		}
		if ( newload ) AS.labels.newload();
	},
	main: 'en',
	newload : () => {
		if (document.documentElement.querySelector('head meta[name="AS.labels.dontLoad"]')) return void(0);
		if (document.documentElement.querySelector('head meta[name="AS.labels.dontLabelize"]')) return void(0);
		if ( AS.labels.newloadstarted ) return void(0);
		AS.labels.newloadstarted = true;
		let c = document.createElement('style');
		c.setAttribute('type','text/css');
		c.setAttribute('class','ASloadingLanguages');
		c.innerHTML = 'body { display: none !important; }';
		document.documentElement.querySelector('head').prepend(c);
// 		if ( isloading ) return isstarted ? void(0) : setTimeout(AS.labels.newload,100);
// 		setTimeout(AS.labels.labelizeAll,100);
		return setTimeout(AS.labels.labelizeAll,100);
	},
	newloadstarted : false,
	page : ( showAll ) => {
		let ns = AS.getNodes('body *[lang]');
		if ( ns.length < 1 ) return void(0);
		if ( showAll ) {
			for ( let i = 0; i < ns.length; i++ ) ns[i].style.display = '';
		} else {
			let re = new RegExp('^(..).*$');
			let ul = AS.labels.main;
			let allLangs = {};
			for ( let i = 0; i < ns.length; i++ ) allLangs[ ns[i].getAttribute('lang').replace(re,"$1").toLowerCase() ] = true;
			if ( ! AS.getCookie('forcelang') ) {
				for ( let i = 0; i < window.navigator.languages.length; i++ ) {
					let l = window.navigator.languages[i].replace(re,"$1").toLowerCase();
					if ( allLangs[l] ) {
						ul = String(l);
						break;
					}
				}
			}
			for ( let i = 0; i < ns.length; i++ ) ns[i].style.display = (( ns[i].getAttribute('lang').replace(re,"$1").toLowerCase() == ul ) ? '' : 'none');
		}
	},
	pending : 0,
	setLanguage : ( mainLang, defaultLang ) => {
		let newload = false;
		if ( typeof mainLang === 'string' ) AS.labels.main = mainLang.toLowerCase();
		if ( typeof defaultLang === 'string' ) AS.labels.def = defaultLang.toLowerCase();
		if ( document.documentElement.querySelector('head meta[name="AS.labels.dontLoadAuto"]')) return void(0);
		let tbl = [ AS.labels.main, AS.labels.def ];
		if (! document.documentElement.querySelector('head meta[name="AS.labels.dontLoadIcons"]')) {
			tbl.push({key:'key4icons',name:'icons'});
		}
		AS.labels.loadmultijs( tbl );
	},
	ready : () => { return !! AS.labels.loaded; },
};

AS.label = ( key, values, lang ) => {
	if ( ! lang ) lang = AS.labels.main;
	let txt = AS.labels.lang[ lang ] ? AS.labels.lang[ lang ][key] : undefined;
	if ( typeof txt === 'undefined' ) txt = AS.labels.lang[ AS.labels.def ][key];
	if ( typeof txt === 'undefined' ) txt = key;
	txt = AS.labels.labelize( txt );
	if ( typeof values === 'object' ) {
		for ( let i in values ) {
			let re;
			if ( (values[i] == '') || (typeof values[i] == 'undefined')) {
				re = new RegExp('\{\{'+i+'\}\}','g');
			} else {
				re = new RegExp('\{\{'+i+'(\\|[^}]*)?\}\}','g');
			}
			txt = txt.replace( re, String(values[i]) );
		}
	}
	txt = txt.replace(/\{\{[^|}]+\|([^}]*)\}\}/g,"$1");
	return txt;
};

AS.icon = ( i ) => {
	let e;
	let icode = AS.labels.lang.icons[i];
	if ( AS.test.udef(icode) ) icode = i;
	if ( icode.indexOf('<') == 0 ) return icode;
	if ( icode.indexOf('{{icon:') == 0 ) return AS.icon( icode.replace(/^\{\{icon:([^}]+).*/, "$1" ) );
	return icode;
};

AS.labels.init();
